/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.records;


import com.tabajara.base.tables.Tanque;
import com.tabajara.base.tables.interfaces.ITanque;

import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import java.sql.Date;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record4;
import org.jooq.Row4;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TanqueRecord extends UpdatableRecordImpl<TanqueRecord> implements VertxPojo, Record4<Integer, String, Date, Integer>, ITanque {

    private static final long serialVersionUID = -1154859615;

    /**
     * Setter for <code>public.tanque.tanid</code>.
     */
    @Override
    public TanqueRecord setTanid(Integer value) {
        set(0, value);
        return this;
    }

    /**
     * Getter for <code>public.tanque.tanid</code>.
     */
    @Override
    public Integer getTanid() {
        return (Integer) get(0);
    }

    /**
     * Setter for <code>public.tanque.tanidentificacao</code>.
     */
    @Override
    public TanqueRecord setTanidentificacao(String value) {
        set(1, value);
        return this;
    }

    /**
     * Getter for <code>public.tanque.tanidentificacao</code>.
     */
    @Override
    public String getTanidentificacao() {
        return (String) get(1);
    }

    /**
     * Setter for <code>public.tanque.tandatainicio</code>.
     */
    @Override
    public TanqueRecord setTandatainicio(Date value) {
        set(2, value);
        return this;
    }

    /**
     * Getter for <code>public.tanque.tandatainicio</code>.
     */
    @Override
    public Date getTandatainicio() {
        return (Date) get(2);
    }

    /**
     * Setter for <code>public.tanque.fkcriacao</code>.
     */
    @Override
    public TanqueRecord setFkcriacao(Integer value) {
        set(3, value);
        return this;
    }

    /**
     * Getter for <code>public.tanque.fkcriacao</code>.
     */
    @Override
    public Integer getFkcriacao() {
        return (Integer) get(3);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<Integer> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record4 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row4<Integer, String, Date, Integer> fieldsRow() {
        return (Row4) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row4<Integer, String, Date, Integer> valuesRow() {
        return (Row4) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field1() {
        return Tanque.TANQUE.TANID;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return Tanque.TANQUE.TANIDENTIFICACAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Date> field3() {
        return Tanque.TANQUE.TANDATAINICIO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field4() {
        return Tanque.TANQUE.FKCRIACAO;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component1() {
        return getTanid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getTanidentificacao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date component3() {
        return getTandatainicio();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component4() {
        return getFkcriacao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value1() {
        return getTanid();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getTanidentificacao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Date value3() {
        return getTandatainicio();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value4() {
        return getFkcriacao();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TanqueRecord value1(Integer value) {
        setTanid(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TanqueRecord value2(String value) {
        setTanidentificacao(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TanqueRecord value3(Date value) {
        setTandatainicio(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TanqueRecord value4(Integer value) {
        setFkcriacao(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public TanqueRecord values(Integer value1, String value2, Date value3, Integer value4) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        return this;
    }

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public void from(ITanque from) {
        setTanid(from.getTanid());
        setTanidentificacao(from.getTanidentificacao());
        setTandatainicio(from.getTandatainicio());
        setFkcriacao(from.getFkcriacao());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public <E extends ITanque> E into(E into) {
        into.from(this);
        return into;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached TanqueRecord
     */
    public TanqueRecord() {
        super(Tanque.TANQUE);
    }

    /**
     * Create a detached, initialised TanqueRecord
     */
    public TanqueRecord(Integer tanid, String tanidentificacao, Date tandatainicio, Integer fkcriacao) {
        super(Tanque.TANQUE);

        set(0, tanid);
        set(1, tanidentificacao);
        set(2, tandatainicio);
        set(3, fkcriacao);
    }

    public TanqueRecord(io.vertx.core.json.JsonObject json) {
        this();
        fromJson(json);
    }
}
